#include <Strela.h>
#include <Wire.h>
#include <Servo.h>

#define TRIGPIN   P6
#define ECHOPIN   P5
#define TRIGPIN_2 P8
#define ECHOPIN_2 P7

#define KP_PIN			P11		 //
#define DELAY_PIN		P11		 //
#define V_PIN			P12		 //

/****** Требуемые регулировки :********/
/*	1-Скорость тягового мотора  *************/
/*	2-К рассогласования УЗ от 0 до 2*************/
/*	3-Задержка на опрос датчиков К. *************/
#define SENSOR_R        P3       //пин, к которому подключен первый датчик
#define SENSOR_L        P4       //пин, к которому подключен второй датчик

#define DELAY 100
#define RANGE_DEVIATION 30

#define RANGE_MAX 200

//#define DBG_SERVO
//#define DBG_MOTOR
//#define DBG_ECHO
#define DBG_LINE
#define DBG_RANGE

#define ZERO_ANGLE		90

#define LOW_ANGLE_M  	70
#define HIGH_ANGLE_M 	50

#define LOW_ANGLE_P		115
#define HIGH_ANGLE_P	150



#define BUTTON_ON   S3
#define BUTTON_CAL  S1

#define LED_POWER L3
#define LED_CAL L1

#define LED_LINE L2

Servo myservo;  // create servo object to control a servo
// twelve servo objects can be created on most boards
#define SERVOPIN  P1

byte Power = 0;					// Статус переменная для управления питанием робота
byte Cal = 0;
byte c=0;

int cm, cm_old,cm_2_old,  cm_2;

unsigned int v_start = 100;
unsigned int		 v_mot;
unsigned int s_angle = 90;

int			 P ;			
float 		 kp = 2;			 // коэффициент разности
float		 k_delay;


String inputString = "";         // a string to hold incoming data
boolean stringComplete = false;  // whether the string is complete

void setup()
{
  Serial.begin (115200);
  inputString.reserve(100);
  
  uPinMode(TRIGPIN, OUTPUT);
  uPinMode(ECHOPIN, INPUT);
  uPinMode(TRIGPIN_2, OUTPUT);
  uPinMode(ECHOPIN_2, INPUT);
  
  myservo.attach(SERVOPIN);  		// attaches the servo on pin 9 to the servo object
  motorConnection(1,1);
  myservo.write (90);
  
  tone(BUZZER, 1000, 150);
}

void loop()
{
	
if (uDigitalRead(BUTTON_ON) == HIGH)	
{
	delay(300); 
	if(uDigitalRead(BUTTON_ON) == HIGH)
		{
			if (Power == 1) {Power = 0;		uDigitalWrite(LED_POWER,LOW);}
			else 			{Power = 1;	   uDigitalWrite(LED_POWER,HIGH);}		// Индикация режима работы робота
		}
}
	
if (uDigitalRead(BUTTON_CAL) == HIGH)	
{
	delay(300); 
	if(uDigitalRead(BUTTON_CAL) == HIGH)
		{
			if (Cal == 1) 	{Cal = 0; 	uDigitalWrite(LED_CAL,LOW);}
			else 			{Cal = 1; 	uDigitalWrite(LED_CAL,HIGH);}
		}
}	
	
if(Power>0)
{
// Считывание показаний УЗ 
	
	
	cm = ECHO1(2);
	if (cm > RANGE_MAX ) 	{cm = RANGE_MAX;} // ограничение диапазона
	
	delay(30);
	
	cm_2 =ECHO2(2);	
	if (cm_2 > RANGE_MAX ) 	{cm_2 = RANGE_MAX;}// ограничение диапазона
	
	delay(10);
	
 // Вывод отладочной информации о расстоянии
  #ifdef DBG_RANGE
  Serial.print(cm); 
  Serial.print(" cm ");
  Serial.print(cm_2); 
  Serial.println(" cm ");
  #endif 
  
// delay(DELAY);
  
// Вычисление разности расстояний между дальномерами
  P=(cm-cm_2)*kp;
  
// Управление рулем а также скоростью тяговых моторов
// Выставляем угол поворота и скороость в переменные.

  if 	  (P > 100)				{s_angle = HIGH_ANGLE_M; v_mot = v_start*0.9;}
  else if (P <= 100&& P>= 20)	{s_angle = LOW_ANGLE_M;	 v_mot = v_start*0.9;}
  else if (P < 20 && P>=0 ) 	{s_angle = ZERO_ANGLE;   v_mot = v_start;}  
  else if (P > -20&& P <=0) 	{s_angle = ZERO_ANGLE;   v_mot = v_start;}
  else if (P >= -100 && P <=-20){s_angle = LOW_ANGLE_P;  v_mot = v_start*0.9;}
  //else if  P < -100 			{myservo.write (0);   m1 = 150;}
  else 							{s_angle = HIGH_ANGLE_P; v_mot = v_start*0.9;}

// Выводим отладку если надо
//#ifdef DBG_SERVO
	Serial.print(" P= ");
	Serial.println(P);  
	Serial.print(" Angle = ");  
	Serial.println(s_angle); ;
//#endif
// Непосредственно управление
	myservo.write	(s_angle);

	drive			(v_mot,v_mot);
	
	Serial.print    ("v_mot = ");	
	Serial.println  (v_mot);
  
#ifdef DBG_MOTOR
	drive(0,0);
#endif

	STOP_LINE_DETECT(2);	
   //delay(DELAY); // Задержка на опрос */
}
else 
{
	drive(0,0);
	myservo.write(90);

}

if(Cal==1)
{
	if (Cal==1)
{
									//Значение от 0 до 2.5
	kp = analogRead(KP_PIN);
	k_delay = analogRead(DELAY_PIN);
	v_start = analogRead(V_PIN);
	
	
	kp = kp/255;					//Значение от 0 до 4
	k_delay = k_delay/400;
	v_start = v_start/4;			// 0-250

	Serial.print("kp = ");
	Serial.println(kp);
	Serial.print("k_delay = ");
	Serial.println(k_delay);	
	Serial.print("v_start = ");
	Serial.println(v_start);	
	
	delay(300);
}
/*********************************************************************************************/	
}

}

unsigned int ECHO1(byte Cycles)
{
	unsigned int duration=0,i=0,cm ;
	
	for (i=0;i<Cycles;i++)			// Накопление данных
	{
	// Считываем дальномер
	  uDigitalWrite(TRIGPIN, LOW); 
	  delayMicroseconds(2);
	  uDigitalWrite(TRIGPIN, HIGH); 
	  delayMicroseconds(10); 
	  uDigitalWrite(TRIGPIN, LOW);
	
	  cm = pulseIn(ECHOPIN, HIGH); // получаем длину
	  cm=cm/58;					   // переводим в см
	  
	  duration +=cm; 			   // накапливаем
	  
	  #ifdef DBG_ECHO
	   Serial.println(duration);
	  #endif 
	}

	duration = duration/Cycles;	   // усредняем

	return (int)duration; 			// возвращаем 
}

unsigned int ECHO2(byte Cycles)
{
	unsigned int duration_2=0,i=0,cm;
	
	for (i=0;i<Cycles;i++)
	{
	  uDigitalWrite(TRIGPIN_2, LOW); 
	  delayMicroseconds(2);
	  uDigitalWrite(TRIGPIN_2, HIGH); 
	  delayMicroseconds(10); 
	  uDigitalWrite(TRIGPIN_2, LOW);
		cm = pulseIn(ECHOPIN_2, HIGH);
		cm=cm/58;
		
	  duration_2 =duration_2+cm;  
	  #ifdef DBG_ECHO
	   Serial.println(duration_2);
	  #endif
	}

	duration_2 = duration_2/Cycles;

	return (int)duration_2; 
}  
/***** Детектирование стоп линии. Отключение робота при наезде на черную линию
		duration задает время отслеживания линии (помехоустойчивость)
		Используются цифровые датчики.
****/
void STOP_LINE_DETECT (byte duration)
{
	#ifdef DBG_LINE
	byte var;
	var = uDigitalRead(SENSOR_R);	
	Serial.print    ("SENSOR_R = ");	
	Serial.println  (var);
	
	var = uDigitalRead(SENSOR_L);
	Serial.print    ("SENSOR_L = ");	
	Serial.println  (var);
	#endif
	
	if(uDigitalRead(SENSOR_R)&&uDigitalRead(SENSOR_R))
	{
		uDigitalWrite(LED_LINE,HIGH);
		c++;
		if (c>=duration){Power=0;uDigitalWrite(LED_POWER,LOW);c=0;}
	}
	else {c=0;uDigitalWrite(LED_LINE,LOW);}
}
/*      Калибровка сенсора     */
//  Входные данные (пин датчика, пин кнопки калибровки, статусный светик)
//  Переменные - значение белого цвета, черного цвета, граница серого
//  Алгоритм : по нажатию кнопки мигать светиком 200мс, ожидая 2 нажатия, будем считывать белый цвет
//  по нажатию светик загорается полностью на секунду, во время этого происходит считывание белого.
//  далее снова мигаем часто, ждем 3 нажатия, по нему снова горит 1 сек, считываем черный цвет. 
//  после окончания процедуры светик гаснеТ, все.

/* Calibrate(int Sense_pin,int But_cal_pin, int Led_pin)
{
	uPinMode(Led_pin, OUTPUT);
	if (uDigitalRead(But_cal_pin) == HIGH) 
	{
		uDigitalWrite(Led_pin,HIGH);
		delay(200);
		uDigitalWrite(Led_pin,LOW);
		delay(200);
	}
	
} */